﻿using System;
using System.Drawing;
using System.Windows.Forms;

namespace ImagesInWinforms_Dispose
{
    public partial class Form1 : Form
    {
        private int Index = 0;
        private Image LoadedImage = null;
        
        public Form1()
        {
            InitializeComponent();
        }

        private void btnChooseImage_Click(object sender, EventArgs e)
        {
            if (LoadedImage != null)
            {
                MessageBox.Show("Image already loaded.");
                return;
            }

            DialogResult tDialogResult = dlgOpenFile.ShowDialog();

            if (tDialogResult != DialogResult.OK)
            {
                return;
            }

            string tSelectedFilePath = dlgOpenFile.FileName;

            this.LoadedImage = Image.FromFile(tSelectedFilePath);

            txtSelectedImageFile.Text = tSelectedFilePath;
        }

        private void btnLoadIntoPicBox_Click(object sender, EventArgs e)
        {
            if (this.LoadedImage == null)
            {
                MessageBox.Show("No image loaded.");
                return;
            }

            pboxImageBox.Image = this.LoadedImage;
        }

        private DataGridViewRow MakeRow()
        {
            DataGridViewRow qRow = new DataGridViewRow();

            DataGridViewTextBoxCell tIndexCell = new DataGridViewTextBoxCell();

            DataGridViewImageCell tImageCell = new DataGridViewImageCell();

            tIndexCell.Value = this.Index;
            tImageCell.Value = this.LoadedImage;

            qRow.Cells.Add(tIndexCell);
            qRow.Cells.Add(tImageCell);

            return qRow;

        }
        

        private void btnLoadIntoGrid_Click(object sender, EventArgs e)
        {
            if (this.LoadedImage == null)
            {
                MessageBox.Show("No image loaded.");
                return;
            }

            DataGridViewRow tNewRow = MakeRow();

            dgImageGrid.Rows.Add(tNewRow);

        }

        private void btnDispose_Click(object sender, EventArgs e)
        {
            if (this.LoadedImage == null)
            {
                MessageBox.Show("No image loaded.");
                return;
            }

            this.LoadedImage.Dispose();
            this.LoadedImage = null;

            txtSelectedImageFile.Text = "";

        }
    }
}
